//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "resource.h"
#include "main.h"



BOOLEAN InitLibFuncs()
{ 
	hLib201 = LoadLibrary ("M201_SP.dll");
    if(!hLib201) return FALSE;

	EX_SetDevToIniSetup = (P_DLL_EX_SetDevToIniSetup)GetProcAddress(hLib201, "EX_SetDevToIniSetup");
	if(!EX_SetDevToIniSetup) return FALSE;

	EX_WriteCurrentConfigToIniFile = (P_DLL_EX_WriteCurrentConfigToIniFile)GetProcAddress(hLib201, "EX_WriteCurrentConfigToIniFile");
	if(!EX_WriteCurrentConfigToIniFile) return FALSE;

	EX_Run = (P_DLL_EX_Run)GetProcAddress(hLib201, "EX_Run");
	if(!EX_Run) return FALSE;

	EX_Stop = (P_DLL_EX_Stop)GetProcAddress(hLib201, "EX_Stop");
	if(!EX_Stop) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nLoading settings from M201_SP.INI\n");
	if(!EX_SetDevToIniSetup())
	{ printf("Failed to load settings from M201_SP.INI"); getch(); return 0;}


	printf("Success loading saved settings\nStarting RUN -  please wait. . .");
	if(!EX_Run())
	{ printf("Failed calling  EX_Run()"); getch(); return 0;}

	printf("\n\nRUNNING and logging to ScanLog_x.txt\nPress 'Q' to stop run and quit  ");

	char(cUserInputVal);

	while((cUserInputVal != 'Q') && (cUserInputVal != 'q'))
	{
		cUserInputVal = (char)getch();
		switch(cUserInputVal)
		{
			case 'Q': case 'q':
				if(!EX_Stop()) printf("Failed calling  EX_Stop()");
				else printf("\n\nSuccess calling  EX_Stop()"); 
				printf("\npress any key to continue to exit\n");
				getch();
				break;
		}
	}

	//The following can also be done, but we won't since nothing was changed.
	//if(!EX_WriteCurrentConfigToIniFile())
	//{ printf("Failed to save config settings settings from M201_SP.INI"); getch(); return 0;}




	return 1;
}
